/*-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2003 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "xbasic_types.h"
#include <xtmrctr_l.h>
#include <xparameters.h>
#define DATAREAD 0x0
#define ADDRREAD 0x1


// Located in: microblaze_0/include/xparameters.h

/*extern int _start;
extern int _exception_handler;
extern int __interrupt_handler;*/

//====================================================

int main (void) {

Xuint32 data, tim;
int x;
	
	
//Output to UART specifing that code is running from SRAM
   print("\n\r-- Running from SRAM() --\n\r");

/*//Resets the Reset, exception and interrupt handlers
print("Resetting reset, exception and interrupt handlers \n\r");
print("based on RUN_FRAM_SRAM compiler derivatives.\n\r");
	//inserts a jump instruction at 0x0 (MicroBlaze Reset) to jump to the 
	//start of the RUN_FROM_SRAM program as specifed by the handler by _start
	// during the compilation of RUN_FROM_SRAM
	//  The compiler will create thw following warning that can be safely ignored:
	//		"warning: initialization makes integer from pointer without a cast"
	x = &_start;
	*(int*)(0x0) = 0xb0000000 | (((x-1) & 0xFFFF0000) >> 16 );
	*(int*)(0x4) = 0xb8000000 | (((x-1) & 0xFFFF));

	// inserts a jump instruction at 0x8 (MicroBlaze exception handler) to 
	// jump to the exception handler of the RUN_FROM_SRAM program as 
	// specifed by the handler by _exception_handler
	// during the compilation of RUN_FROM_SRAM
	//  The compiler will create thw following warning that can be safely ignored:
	//		"warning: initialization makes integer from pointer without a cast"
	x = &_exception_handler;
	*(int*)(0x8) = 0xb0000000 | (((x-1) & 0xFFFF0000) >> 16 );
	*(int*)(0xB) = 0xb8000000 | (((x-1) & 0xFFFF));

	// inserts a jump instruction at 0x10 (MicroBlaze interrupt handler) to 
	// jump to the interrupt handler of the RUN_FROM_SRAM program as 
	// specifed by the handler by _interrupt_handler 
	// during the compilation of RUN_FROM_SRAM	
	//  The compiler will create thw following warning that can be safely ignored:
	//		"warning: initialization makes integer from pointer without a cast"
	x = &__interrupt_handler;
	*(int*)(0x10) = 0xb0000000 | (((x-1) & 0xFFFF0000) >> 16 );
	*(int*)(0x14) = 0xb8000000 | (((x-1) & 0xFFFF));

*/

   	//to return a 32-bit word stores after the sync word
  /***************/
  /* Start timer */
  /***************/


   XTmrCtr_mSetLoadReg(XPAR_MYTIMER_BASEADDR, 0, 0x00000000);
   XTmrCtr_mLoadTimerCounterReg(XPAR_MYTIMER_BASEADDR, 0);
   
   XTmrCtr_mSetControlStatusReg(XPAR_MYTIMER_BASEADDR, 0, XTC_CSR_ENABLE_TMR_MASK ); 
	data=promread(DATAREAD);
	
  /**************/
  /* Stop timer */
  /**************/
 XTmrCtr_mSetControlStatusReg(XPAR_MYTIMER_BASEADDR, 0, 0); 
// Xilinx specific stop read timer
 tim = XTimerCtr_mReadReg(XPAR_MYTIMER_BASEADDR, 0, 8);

//   xil_printf ("MicroBlaze Running time was %d cycles\n\r",tim);
	xil_printf("\n\rThe time required to read the 32-bit word 0x%x, found in the PROM after \n\r", data);
	xil_printf("the Data Sync Word 0x8f9fafbf as specified in user_data.txt, was %d clock ticks at 50 Mhz\n\r", tim);
   
	print("\n\r-- End Running from SRAM() --\n\r");   
   return 0;
}


